<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

		if( !isset( $lookupTableLinks["pimpin_teras_mast"] ) ) {
			$lookupTableLinks["pimpin_teras_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_teras_mast"]["pimpin_rubrik_mast.teras_kod"] )) {
			$lookupTableLinks["pimpin_teras_mast"]["pimpin_rubrik_mast.teras_kod"] = array();
		}
		$lookupTableLinks["pimpin_teras_mast"]["pimpin_rubrik_mast.teras_kod"]["edit"] = array("table" => "pimpin_rubrik_mast", "field" => "teras_kod", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["pelajar_eva.pelajar_kp"] )) {
			$lookupTableLinks["student"]["pelajar_eva.pelajar_kp"] = array();
		}
		$lookupTableLinks["student"]["pelajar_eva.pelajar_kp"]["edit"] = array("table" => "pelajar_eva", "field" => "pelajar_kp", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["pelajar_eva.pelajar_nama"] )) {
			$lookupTableLinks["student"]["pelajar_eva.pelajar_nama"] = array();
		}
		$lookupTableLinks["student"]["pelajar_eva.pelajar_nama"]["edit"] = array("table" => "pelajar_eva", "field" => "pelajar_nama", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_kod_rub"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_kod_rub"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_kod_rub"]["edit"] = array("table" => "pelajar_eva", "field" => "eva_kod_rub", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_rubrik_teras"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_rubrik_teras"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pelajar_eva.eva_rubrik_teras"]["edit"] = array("table" => "pelajar_eva", "field" => "eva_rubrik_teras", "page" => "edit");
		if( !isset( $lookupTableLinks["fasi_pesat"] ) ) {
			$lookupTableLinks["fasi_pesat"] = array();
		}
		if( !isset( $lookupTableLinks["fasi_pesat"]["pelajar_eva.pel_fasi"] )) {
			$lookupTableLinks["fasi_pesat"]["pelajar_eva.pel_fasi"] = array();
		}
		$lookupTableLinks["fasi_pesat"]["pelajar_eva.pel_fasi"]["edit"] = array("table" => "pelajar_eva", "field" => "pel_fasi", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.no"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.no"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.no"]["edit"] = array("table" => "pel_pimpin_eva", "field" => "no", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.kod_rubik"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.kod_rubik"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.kod_rubik"]["edit"] = array("table" => "pel_pimpin_eva", "field" => "kod_rubik", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.rubik_nama"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.rubik_nama"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva.rubik_nama"]["edit"] = array("table" => "pel_pimpin_eva", "field" => "rubik_nama", "page" => "edit");
		if( !isset( $lookupTableLinks["pelajar_eva"] ) ) {
			$lookupTableLinks["pelajar_eva"] = array();
		}
		if( !isset( $lookupTableLinks["pelajar_eva"]["pel_pimpin_eva.pelajar_kp"] )) {
			$lookupTableLinks["pelajar_eva"]["pel_pimpin_eva.pelajar_kp"] = array();
		}
		$lookupTableLinks["pelajar_eva"]["pel_pimpin_eva.pelajar_kp"]["edit"] = array("table" => "pel_pimpin_eva", "field" => "pelajar_kp", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["pel_pimpin_eva.pelajar_nama"] )) {
			$lookupTableLinks["student"]["pel_pimpin_eva.pelajar_nama"] = array();
		}
		$lookupTableLinks["student"]["pel_pimpin_eva.pelajar_nama"]["edit"] = array("table" => "pel_pimpin_eva", "field" => "pelajar_nama", "page" => "edit");
		if( !isset( $lookupTableLinks["pelajar_eva"] ) ) {
			$lookupTableLinks["pelajar_eva"] = array();
		}
		if( !isset( $lookupTableLinks["pelajar_eva"]["kehadiran_prog.kp_pelajar"] )) {
			$lookupTableLinks["pelajar_eva"]["kehadiran_prog.kp_pelajar"] = array();
		}
		$lookupTableLinks["pelajar_eva"]["kehadiran_prog.kp_pelajar"]["edit"] = array("table" => "kehadiran_prog", "field" => "kp_pelajar", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["kehadiran_prog.nama_pel"] )) {
			$lookupTableLinks["student"]["kehadiran_prog.nama_pel"] = array();
		}
		$lookupTableLinks["student"]["kehadiran_prog.nama_pel"]["edit"] = array("table" => "kehadiran_prog", "field" => "nama_pel", "page" => "edit");
		if( !isset( $lookupTableLinks["program_pel"] ) ) {
			$lookupTableLinks["program_pel"] = array();
		}
		if( !isset( $lookupTableLinks["program_pel"]["kehadiran_prog.kod_program"] )) {
			$lookupTableLinks["program_pel"]["kehadiran_prog.kod_program"] = array();
		}
		$lookupTableLinks["program_pel"]["kehadiran_prog.kod_program"]["edit"] = array("table" => "kehadiran_prog", "field" => "kod_program", "page" => "edit");
		if( !isset( $lookupTableLinks["program_pel"] ) ) {
			$lookupTableLinks["program_pel"] = array();
		}
		if( !isset( $lookupTableLinks["program_pel"]["kehadiran_prog.nama_program"] )) {
			$lookupTableLinks["program_pel"]["kehadiran_prog.nama_program"] = array();
		}
		$lookupTableLinks["program_pel"]["kehadiran_prog.nama_program"]["edit"] = array("table" => "kehadiran_prog", "field" => "nama_program", "page" => "edit");
		if( !isset( $lookupTableLinks["pelajar_eva"] ) ) {
			$lookupTableLinks["pelajar_eva"] = array();
		}
		if( !isset( $lookupTableLinks["pelajar_eva"]["jawatan_peranan.kp_pelajar"] )) {
			$lookupTableLinks["pelajar_eva"]["jawatan_peranan.kp_pelajar"] = array();
		}
		$lookupTableLinks["pelajar_eva"]["jawatan_peranan.kp_pelajar"]["edit"] = array("table" => "jawatan_peranan", "field" => "kp_pelajar", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["jawatan_peranan.nama_pelajar"] )) {
			$lookupTableLinks["student"]["jawatan_peranan.nama_pelajar"] = array();
		}
		$lookupTableLinks["student"]["jawatan_peranan.nama_pelajar"]["edit"] = array("table" => "jawatan_peranan", "field" => "nama_pelajar", "page" => "edit");
		if( !isset( $lookupTableLinks["fasi_pesat"] ) ) {
			$lookupTableLinks["fasi_pesat"] = array();
		}
		if( !isset( $lookupTableLinks["fasi_pesat"]["fic_pelajar.kod_fasi"] )) {
			$lookupTableLinks["fasi_pesat"]["fic_pelajar.kod_fasi"] = array();
		}
		$lookupTableLinks["fasi_pesat"]["fic_pelajar.kod_fasi"]["edit"] = array("table" => "fic_pelajar", "field" => "kod_fasi", "page" => "edit");
		if( !isset( $lookupTableLinks["fasi_pesat"] ) ) {
			$lookupTableLinks["fasi_pesat"] = array();
		}
		if( !isset( $lookupTableLinks["fasi_pesat"]["fic_pelajar.nama_fasi"] )) {
			$lookupTableLinks["fasi_pesat"]["fic_pelajar.nama_fasi"] = array();
		}
		$lookupTableLinks["fasi_pesat"]["fic_pelajar.nama_fasi"]["edit"] = array("table" => "fic_pelajar", "field" => "nama_fasi", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["fic_pelajar.kp_pelajar"] )) {
			$lookupTableLinks["student"]["fic_pelajar.kp_pelajar"] = array();
		}
		$lookupTableLinks["student"]["fic_pelajar.kp_pelajar"]["edit"] = array("table" => "fic_pelajar", "field" => "kp_pelajar", "page" => "edit");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["fic_pelajar.nama_pelajar"] )) {
			$lookupTableLinks["student"]["fic_pelajar.nama_pelajar"] = array();
		}
		$lookupTableLinks["student"]["fic_pelajar.nama_pelajar"]["edit"] = array("table" => "fic_pelajar", "field" => "nama_pelajar", "page" => "edit");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.no"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.no"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.no"]["search"] = array("table" => "pel_pimpin_eva Chart", "field" => "no", "page" => "search");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.kod_rubik"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.kod_rubik"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.kod_rubik"]["search"] = array("table" => "pel_pimpin_eva Chart", "field" => "kod_rubik", "page" => "search");
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"] ) ) {
			$lookupTableLinks["pimpin_rubrik_mast"] = array();
		}
		if( !isset( $lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.rubik_nama"] )) {
			$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.rubik_nama"] = array();
		}
		$lookupTableLinks["pimpin_rubrik_mast"]["pel_pimpin_eva_chart.rubik_nama"]["search"] = array("table" => "pel_pimpin_eva Chart", "field" => "rubik_nama", "page" => "search");
		if( !isset( $lookupTableLinks["pelajar_eva"] ) ) {
			$lookupTableLinks["pelajar_eva"] = array();
		}
		if( !isset( $lookupTableLinks["pelajar_eva"]["pel_pimpin_eva_chart.pelajar_kp"] )) {
			$lookupTableLinks["pelajar_eva"]["pel_pimpin_eva_chart.pelajar_kp"] = array();
		}
		$lookupTableLinks["pelajar_eva"]["pel_pimpin_eva_chart.pelajar_kp"]["search"] = array("table" => "pel_pimpin_eva Chart", "field" => "pelajar_kp", "page" => "search");
		if( !isset( $lookupTableLinks["student"] ) ) {
			$lookupTableLinks["student"] = array();
		}
		if( !isset( $lookupTableLinks["student"]["pel_pimpin_eva_chart.pelajar_nama"] )) {
			$lookupTableLinks["student"]["pel_pimpin_eva_chart.pelajar_nama"] = array();
		}
		$lookupTableLinks["student"]["pel_pimpin_eva_chart.pelajar_nama"]["search"] = array("table" => "pel_pimpin_eva Chart", "field" => "pelajar_nama", "page" => "search");
}

?>